diff --git a/sys/dev/raid/arcmsr/arcmsr.h b/sys/dev/raid/arcmsr/arcmsr.h
index ed91264..45edfff 100644
--- a/sys/dev/raid/arcmsr/arcmsr.h
+++ b/sys/dev/raid/arcmsr/arcmsr.h
@@ -326,14 +376,310 @@ struct CMD_MESSAGE_FIELD {
 #define ARCMSR_HBCMU_IOP2DRV_DATA_READ_DOORBELL_CLEAR           0x00000004/*outbound DATA READ isr door bell clear*/
 #define ARCMSR_HBCMU_IOP2DRV_MESSAGE_CMD_DONE                   0x00000008/*outbound message 0 ready*/
 #define ARCMSR_HBCMU_IOP2DRV_MESSAGE_CMD_DONE_DOORBELL_CLEAR    0x00000008/*outbound message cmd isr door bell clear*/
-#define ARCMSR_HBCMU_MESSAGE_FIRMWARE_OK		                0x80000000/*ARCMSR_HBCMU_MESSAGE_FIRMWARE_OK*/
+#define ARCMSR_HBCMU_MESSAGE_FIRMWARE_OK		        0x80000000/*ARCMSR_HBCMU_MESSAGE_FIRMWARE_OK*/
+#define ARCMSR_HBCMU_RESET_ADAPTER				0x00000024
+#define ARCMSR_HBCMU_DiagWrite_ENABLE				0x00000080
+
+/* 
+************************************************************************
+**                SPEC. for Areca HBD adapter
+************************************************************************
+*/
+#define ARCMSR_HBDMU_CHIP_ID				0x00004
+#define ARCMSR_HBDMU_CPU_MEMORY_CONFIGURATION		0x00008
+#define ARCMSR_HBDMU_I2_HOST_INTERRUPT_MASK		0x00034
+#define ARCMSR_HBDMU_MAIN_INTERRUPT_STATUS		0x00200
+#define ARCMSR_HBDMU_PCIE_F0_INTERRUPT_ENABLE		0x0020C
+#define ARCMSR_HBDMU_INBOUND_MESSAGE0			0x00400
+#define ARCMSR_HBDMU_INBOUND_MESSAGE1			0x00404
+#define ARCMSR_HBDMU_OUTBOUND_MESSAGE0			0x00420
+#define ARCMSR_HBDMU_OUTBOUND_MESSAGE1			0x00424
+#define ARCMSR_HBDMU_INBOUND_DOORBELL			0x00460
+#define ARCMSR_HBDMU_OUTBOUND_DOORBELL			0x00480
+#define ARCMSR_HBDMU_OUTBOUND_DOORBELL_ENABLE		0x00484
+#define ARCMSR_HBDMU_INBOUND_LIST_BASE_LOW		0x01000
+#define ARCMSR_HBDMU_INBOUND_LIST_BASE_HIGH		0x01004
+#define ARCMSR_HBDMU_INBOUND_LIST_WRITE_POINTER		0x01018
+#define ARCMSR_HBDMU_OUTBOUND_LIST_BASE_LOW		0x01060
+#define ARCMSR_HBDMU_OUTBOUND_LIST_BASE_HIGH		0x01064
+#define ARCMSR_HBDMU_OUTBOUND_LIST_COPY_POINTER		0x0106C
+#define ARCMSR_HBDMU_OUTBOUND_LIST_READ_POINTER		0x01070
+#define ARCMSR_HBDMU_OUTBOUND_INTERRUPT_CAUSE		0x01088
+#define ARCMSR_HBDMU_OUTBOUND_INTERRUPT_ENABLE		0x0108C
+
+#define ARCMSR_HBDMU_MESSAGE_WBUFFER			0x02000
+#define ARCMSR_HBDMU_MESSAGE_RBUFFER			0x02100
+#define ARCMSR_HBDMU_MESSAGE_RWBUFFER			0x02200
+
+#define ARCMSR_HBDMU_ISR_THROTTLING_LEVEL		16
+#define ARCMSR_HBDMU_ISR_MAX_DONE_QUEUE			20
+
+/* Host Interrupt Mask */
+#define ARCMSR_HBDMU_ALL_INT_ENABLE			0x00001010	/* enable all ISR */
+#define ARCMSR_HBDMU_ALL_INT_DISABLE			0x00000000	/* disable all ISR */
+
+/* Host Interrupt Status */
+#define ARCMSR_HBDMU_OUTBOUND_INT			0x00001010
+#define ARCMSR_HBDMU_OUTBOUND_DOORBELL_INT		0x00001000
+#define ARCMSR_HBDMU_OUTBOUND_POSTQUEUE_INT		0x00000010
+
+/* DoorBell*/
+#define ARCMSR_HBDMU_DRV2IOP_DATA_IN_READY		0x00000001
+#define ARCMSR_HBDMU_DRV2IOP_DATA_OUT_READ		0x00000002
+
+#define ARCMSR_HBDMU_IOP2DRV_DATA_WRITE_OK		0x00000001
+#define ARCMSR_HBDMU_IOP2DRV_DATA_READ_OK		0x00000002
+
+/*outbound message 0 ready*/
+#define ARCMSR_HBDMU_IOP2DRV_MESSAGE_CMD_DONE		0x02000000
+
+#define ARCMSR_HBDMU_F0_DOORBELL_CAUSE			0x02000003
+
+/*outbound message cmd isr door bell clear*/
+#define ARCMSR_HBDMU_IOP2DRV_MESSAGE_CMD_DONE_CLEAR	0x02000000
+
+/*outbound list */
+#define ARCMSR_HBDMU_OUTBOUND_LIST_INTERRUPT		0x00000001
+#define ARCMSR_HBDMU_OUTBOUND_LIST_INTERRUPT_CLEAR	0x00000001
+
+/*ARCMSR_HBAMU_MESSAGE_FIRMWARE_OK*/
+#define ARCMSR_HBDMU_MESSAGE_FIRMWARE_OK		0x80000000
+/*
+*********************************************************************
+** Message Unit structure
+*********************************************************************
+*/
+struct HBA_MessageUnit
+{
+	u_int32_t	resrved0[4];		/*0000 000F*/
+	u_int32_t	inbound_msgaddr0;	/*0010 0013*/
+	u_int32_t	inbound_msgaddr1;	/*0014 0017*/
+	u_int32_t	outbound_msgaddr0;	/*0018 001B*/
+	u_int32_t	outbound_msgaddr1;	/*001C 001F*/
+	u_int32_t	inbound_doorbell;	/*0020 0023*/
+	u_int32_t	inbound_intstatus;	/*0024 0027*/
+	u_int32_t	inbound_intmask;	/*0028 002B*/
+	u_int32_t	outbound_doorbell;	/*002C 002F*/
+	u_int32_t	outbound_intstatus;	/*0030 0033*/
+	u_int32_t	outbound_intmask;	/*0034 0037*/
+	u_int32_t	reserved1[2];		/*0038 003F*/
+	u_int32_t	inbound_queueport;	/*0040 0043*/
+	u_int32_t	outbound_queueport;	/*0044 0047*/
+	u_int32_t	reserved2[2];		/*0048 004F*/
+	u_int32_t	reserved3[492];		/*0050 07FF ......local_buffer 492*/
+	u_int32_t	reserved4[128];		/*0800 09FF                    128*/
+	u_int32_t	msgcode_rwbuffer[256];	/*0a00 0DFF                    256*/
+	u_int32_t	message_wbuffer[32];	/*0E00 0E7F                     32*/
+	u_int32_t	reserved5[32];		/*0E80 0EFF                     32*/
+	u_int32_t	message_rbuffer[32];	/*0F00 0F7F                     32*/
+	u_int32_t	reserved6[32];		/*0F80 0FFF                     32*/
+};
+/*
+*********************************************************************
+** 
+*********************************************************************
+*/
+struct HBB_DOORBELL
+{
+	u_int8_t	doorbell_reserved[ARCMSR_DRV2IOP_DOORBELL]; /*reserved */
+	u_int32_t	drv2iop_doorbell;          /*offset 0x00020400:00,01,02,03: window of "instruction flags" from driver to iop */
+	u_int32_t	drv2iop_doorbell_mask;     /*                  04,05,06,07: doorbell mask */
+	u_int32_t	iop2drv_doorbell;          /*                  08,09,10,11: window of "instruction flags" from iop to driver */
+	u_int32_t	iop2drv_doorbell_mask;     /*                  12,13,14,15: doorbell mask */
+};
+/*
+*********************************************************************
+** 
+*********************************************************************
+*/
+struct HBB_RWBUFFER
+{
+	u_int8_t	message_reserved0[ARCMSR_MSGCODE_RWBUFFER];   /*reserved */
+	u_int32_t	msgcode_rwbuffer[256];      /*offset 0x0000fa00:   0,   1,   2,   3,...,1023: message code read write 1024bytes */
+	u_int32_t	message_wbuffer[32];        /*offset 0x0000fe00:1024,1025,1026,1027,...,1151: user space data to iop 128bytes */
+	u_int32_t	message_reserved1[32];      /*                  1152,1153,1154,1155,...,1279: message reserved*/
+	u_int32_t	message_rbuffer[32];        /*offset 0x0000ff00:1280,1281,1282,1283,...,1407: iop data to user space 128bytes */ 
+};
+/*
+*********************************************************************
+** 
+*********************************************************************
+*/
+struct HBB_MessageUnit
+{
+	u_int32_t		post_qbuffer[ARCMSR_MAX_HBB_POSTQUEUE];       /* post queue buffer for iop */
+	u_int32_t		done_qbuffer[ARCMSR_MAX_HBB_POSTQUEUE];       /* done queue buffer for iop */
+	int32_t			postq_index;                                  /* post queue index */
+	int32_t			doneq_index;								   /* done queue index */
+	struct HBB_DOORBELL    *hbb_doorbell;
+	struct HBB_RWBUFFER    *hbb_rwbuffer;
+};
 
 /*
+*********************************************************************
+** 
+*********************************************************************
+*/
+struct HBC_MessageUnit {
+	u_int32_t	message_unit_status;                        /*0000 0003*/
+	u_int32_t	slave_error_attribute;	                    /*0004 0007*/
+	u_int32_t	slave_error_address;	                    /*0008 000B*/
+	u_int32_t	posted_outbound_doorbell;	            /*000C 000F*/
+	u_int32_t	master_error_attribute;	                    /*0010 0013*/
+	u_int32_t	master_error_address_low;	            /*0014 0017*/
+	u_int32_t	master_error_address_high;	            /*0018 001B*/
+	u_int32_t	hcb_size;                                   /*001C 001F size of the PCIe window used for HCB_Mode accesses*/
+	u_int32_t	inbound_doorbell;	                    /*0020 0023*/
+	u_int32_t	diagnostic_rw_data;	                    /*0024 0027*/
+	u_int32_t	diagnostic_rw_address_low;	            /*0028 002B*/
+	u_int32_t	diagnostic_rw_address_high;	            /*002C 002F*/
+	u_int32_t	host_int_status;	                    /*0030 0033 host interrupt status*/
+	u_int32_t	host_int_mask;     	                    /*0034 0037 host interrupt mask*/
+	u_int32_t	dcr_data;	                            /*0038 003B*/
+	u_int32_t	dcr_address;                                /*003C 003F*/
+	u_int32_t	inbound_queueport;                          /*0040 0043 port32 host inbound queue port*/
+	u_int32_t	outbound_queueport;                         /*0044 0047 port32 host outbound queue port*/
+	u_int32_t	hcb_pci_address_low;                        /*0048 004B*/
+	u_int32_t	hcb_pci_address_high;                       /*004C 004F*/
+	u_int32_t	iop_int_status;                             /*0050 0053*/
+	u_int32_t	iop_int_mask;                               /*0054 0057*/
+	u_int32_t	iop_inbound_queue_port;                     /*0058 005B*/
+	u_int32_t	iop_outbound_queue_port;                    /*005C 005F*/
+	u_int32_t	inbound_free_list_index;                    /*0060 0063 inbound free list producer consumer index*/
+	u_int32_t	inbound_post_list_index;                    /*0064 0067 inbound post list producer consumer index*/
+	u_int32_t	outbound_free_list_index;                   /*0068 006B outbound free list producer consumer index*/
+	u_int32_t	outbound_post_list_index;                   /*006C 006F outbound post list producer consumer index*/
+	u_int32_t	inbound_doorbell_clear;                     /*0070 0073*/
+	u_int32_t	i2o_message_unit_control;                   /*0074 0077*/
+	u_int32_t	last_used_message_source_address_low;       /*0078 007B*/
+	u_int32_t	last_used_message_source_address_high;	    /*007C 007F*/
+	u_int32_t	pull_mode_data_byte_count[4];               /*0080 008F pull mode data byte count0..count7*/
+	u_int32_t	message_dest_address_index;                 /*0090 0093*/
+	u_int32_t	done_queue_not_empty_int_counter_timer;     /*0094 0097*/
+	u_int32_t	utility_A_int_counter_timer;                /*0098 009B*/
+	u_int32_t	outbound_doorbell;                          /*009C 009F*/
+	u_int32_t	outbound_doorbell_clear;                    /*00A0 00A3*/
+	u_int32_t	message_source_address_index;               /*00A4 00A7 message accelerator source address consumer producer index*/
+	u_int32_t	message_done_queue_index;                   /*00A8 00AB message accelerator completion queue consumer producer index*/
+	u_int32_t	reserved0;                                  /*00AC 00AF*/
+	u_int32_t	inbound_msgaddr0;                           /*00B0 00B3 scratchpad0*/
+	u_int32_t	inbound_msgaddr1;                           /*00B4 00B7 scratchpad1*/
+	u_int32_t	outbound_msgaddr0;                          /*00B8 00BB scratchpad2*/
+	u_int32_t	outbound_msgaddr1;                          /*00BC 00BF scratchpad3*/
+	u_int32_t	inbound_queueport_low;                      /*00C0 00C3 port64 host inbound queue port low*/
+	u_int32_t	inbound_queueport_high;                     /*00C4 00C7 port64 host inbound queue port high*/
+	u_int32_t	outbound_queueport_low;                     /*00C8 00CB port64 host outbound queue port low*/
+	u_int32_t	outbound_queueport_high;                    /*00CC 00CF port64 host outbound queue port high*/
+	u_int32_t	iop_inbound_queue_port_low;                 /*00D0 00D3*/
+	u_int32_t	iop_inbound_queue_port_high;                /*00D4 00D7*/
+	u_int32_t	iop_outbound_queue_port_low;                /*00D8 00DB*/
+	u_int32_t	iop_outbound_queue_port_high;               /*00DC 00DF*/
+	u_int32_t	message_dest_queue_port_low;                /*00E0 00E3 message accelerator destination queue port low*/
+	u_int32_t	message_dest_queue_port_high;               /*00E4 00E7 message accelerator destination queue port high*/
+	u_int32_t	last_used_message_dest_address_low;         /*00E8 00EB last used message accelerator destination address low*/
+	u_int32_t	last_used_message_dest_address_high;        /*00EC 00EF last used message accelerator destination address high*/
+	u_int32_t	message_done_queue_base_address_low;        /*00F0 00F3 message accelerator completion queue base address low*/
+	u_int32_t	message_done_queue_base_address_high;       /*00F4 00F7 message accelerator completion queue base address high*/
+	u_int32_t	host_diagnostic;                            /*00F8 00FB*/
+	u_int32_t	write_sequence;                             /*00FC 00FF*/
+	u_int32_t	reserved1[34];                              /*0100 0187*/
+	u_int32_t	reserved2[1950];                            /*0188 1FFF*/
+	u_int32_t	message_wbuffer[32];                        /*2000 207F*/
+	u_int32_t	reserved3[32];                              /*2080 20FF*/
+	u_int32_t	message_rbuffer[32];                        /*2100 217F*/
+	u_int32_t	reserved4[32];                              /*2180 21FF*/
+	u_int32_t	msgcode_rwbuffer[256];                      /*2200 23FF*/
+};
+/*
+*********************************************************************
+** 
+*********************************************************************
+*/
+struct InBound_SRB {
+	uint32_t addressLow; //pointer to SRB block
+	uint32_t addressHigh;
+	uint32_t length; // in DWORDs
+	uint32_t reserved0;
+};
+
+struct OutBound_SRB {
+	uint32_t addressLow; //pointer to SRB block
+	uint32_t addressHigh;
+};
+
+struct HBD_MessageUnit {
+	uint32_t reserved0;
+	uint32_t chip_id;			//0x0004
+	uint32_t cpu_mem_config;		//0x0008
+	uint32_t reserved1[10];			//0x000C
+	uint32_t i2o_host_interrupt_mask;	//0x0034
+	uint32_t reserved2[114];		//0x0038
+	uint32_t host_int_status;		//0x0200
+	uint32_t host_int_enable;		//0x0204
+	uint32_t reserved3[1];			//0x0208
+	uint32_t pcief0_int_enable;		//0x020C
+	uint32_t reserved4[124];		//0x0210
+	uint32_t inbound_msgaddr0;		//0x0400
+	uint32_t inbound_msgaddr1;		//0x0404
+	uint32_t reserved5[6];			//0x0408
+	uint32_t outbound_msgaddr0;		//0x0420
+	uint32_t outbound_msgaddr1;		//0x0424
+	uint32_t reserved6[14];			//0x0428
+	uint32_t inbound_doorbell;		//0x0460
+	uint32_t reserved7[7];			//0x0464
+	uint32_t outbound_doorbell;		//0x0480
+	uint32_t outbound_doorbell_enable;	//0x0484
+	uint32_t reserved8[734];		//0x0488
+	uint32_t inboundlist_base_low;		//0x1000
+	uint32_t inboundlist_base_high;		//0x1004
+	uint32_t reserved9[4];			//0x1008
+	uint32_t inboundlist_write_pointer;	//0x1018
+	uint32_t inboundlist_read_pointer;	//0x101C
+	uint32_t reserved10[16];		//0x1020
+	uint32_t outboundlist_base_low;		//0x1060
+	uint32_t outboundlist_base_high;	//0x1064
+	uint32_t reserved11;			//0x1068
+	uint32_t outboundlist_copy_pointer;	//0x106C
+	uint32_t outboundlist_read_pointer;	//0x1070 0x1072
+	uint32_t reserved12[5];			//0x1074
+	uint32_t outboundlist_interrupt_cause;	//0x1088
+	uint32_t outboundlist_interrupt_enable;	//0x108C
+	uint32_t reserved13[988];		//0x1090
+	uint32_t message_wbuffer[32];		//0x2000
+	uint32_t reserved14[32];		//0x2080
+	uint32_t message_rbuffer[32];		//0x2100
+	uint32_t reserved15[32];		//0x2180
+	uint32_t msgcode_rwbuffer[256];		//0x2200
+};
+
+struct HBD_MessageUnit0 {
+ 	struct InBound_SRB post_qbuffer[ARCMSR_MAX_HBD_POSTQUEUE];
+   	struct OutBound_SRB done_qbuffer[ARCMSR_MAX_HBD_POSTQUEUE+1];
+	uint16_t postq_index;
+	uint16_t doneq_index;
+	struct HBD_MessageUnit	*phbdmu;
+};
+
+/*
+*********************************************************************
+** 
+*********************************************************************
+*/
+struct MessageUnit_UNION
+{
+	union	{
+		struct HBA_MessageUnit		hbamu;
+		struct HBB_MessageUnit		hbbmu;
+        	struct HBC_MessageUnit		hbcmu;
+        	struct HBD_MessageUnit0		hbdmu;
+	} muu;
+};
+/* 
 *************************************************************
-**   structure for holding DMA address data
+**   structure for holding DMA address data 
 *************************************************************
 */
-#define IS_SG64_ADDR                0x01000000 /* bit24 */
+#define IS_SG64_ADDR	0x01000000 /* bit24 */
 /*
 ************************************************************************************************
 **                            ARECA FIRMWARE SPEC
@@ -342,10 +688,10 @@ struct CMD_MESSAGE_FIELD {
 **		(All In/Out is in IOP331's view)
 **		1. Message 0 --> InitThread message and retrun code
 **		2. Doorbell is used for RS-232 emulation
-**				inDoorBell :    bit0 -- data in ready            (DRIVER DATA WRITE OK)
-**								bit1 -- data out has been read   (DRIVER DATA READ OK)
-**				outDooeBell:    bit0 -- data out ready           (IOP331 DATA WRITE OK)
-**								bit1 -- data in has been read    (IOP331 DATA READ OK)
+**			inDoorBell :    bit0 -- data in ready            (DRIVER DATA WRITE OK)
+**					bit1 -- data out has been read   (DRIVER DATA READ OK)
+**			outDooeBell:    bit0 -- data out ready           (IOP331 DATA WRITE OK)
+**					bit1 -- data in has been read    (IOP331 DATA READ OK)
 **		3. Index Memory Usage
 **			offset 0xf00 : for RS232 out (request buffer)
 **			offset 0xe00 : for RS232 in  (scratch buffer)
@@ -357,74 +703,74 @@ struct CMD_MESSAGE_FIELD {
 **			        Byte 4--127 : Max 124 bytes of data
 **		5. PostQ
 **		All SCSI Command must be sent through postQ:
-**		(inbound queue port)	Request frame must be 32 bytes aligned
-**            #   bit27--bit31 => flag for post ccb
-**			  #   bit0--bit26 => real address (bit27--bit31) of post arcmsr_cdb
-**													bit31 : 0 : 256 bytes frame
-**															1 : 512 bytes frame
-**													bit30 : 0 : normal request
-**															1 : BIOS request
-**                                                  bit29 : reserved
-**                                                  bit28 : reserved
-**                                                  bit27 : reserved
+**		(inbound queue port)	Request frame must be 32 bytes aligned 
+**              	#   bit27--bit31 => flag for post ccb 
+**			#   bit0--bit26 => real address (bit27--bit31) of post arcmsr_cdb  
+**					bit31 : 0 : 256 bytes frame
+**						1 : 512 bytes frame
+**					bit30 : 0 : normal request
+**						1 : BIOS request
+**                                      bit29 : reserved
+**                                      bit28 : reserved
+**                                      bit27 : reserved
 **  -------------------------------------------------------------------------------
-**		(outbount queue port)	Request reply
-**            #   bit27--bit31 => flag for reply
-**			  #   bit0--bit26 => real address (bit27--bit31) of reply arcmsr_cdb
-**													bit31 : must be 0 (for this type of reply)
-**													bit30 : reserved for BIOS handshake
-**													bit29 : reserved
-**													bit28 : 0 : no error, ignore AdapStatus/DevStatus/SenseData
-**															1 : Error, error code in AdapStatus/DevStatus/SenseData
-**													bit27 : reserved
+**		(outbount queue port)	Request reply                          
+**              	#   bit27--bit31 => flag for reply
+**			#   bit0--bit26 => real address (bit27--bit31) of reply arcmsr_cdb 
+**			bit31 : must be 0 (for this type of reply)
+**			bit30 : reserved for BIOS handshake
+**			bit29 : reserved
+**			bit28 : 0 : no error, ignore AdapStatus/DevStatus/SenseData
+**				1 : Error, error code in AdapStatus/DevStatus/SenseData
+**			bit27 : reserved
 **		6. BIOS request
 **			All BIOS request is the same with request from PostQ
 **			Except :
 **				Request frame is sent from configuration space
-**								offset: 0x78 : Request Frame (bit30 == 1)
-**								offset: 0x18 : writeonly to generate IRQ to IOP331
+**					offset: 0x78 : Request Frame (bit30 == 1)
+**					offset: 0x18 : writeonly to generate IRQ to IOP331
 **				Completion of request:
-**				                      (bit30 == 0, bit28==err flag)
+**				        (bit30 == 0, bit28==err flag)
 **		7. Definition of SGL entry (structure)
 **		8. Message1 Out - Diag Status Code (????)
 **		9. Message0 message code :
 **			0x00 : NOP
 **			0x01 : Get Config ->offset 0xa00 :for outbound message code msgcode_rwbuffer (IOP331 send to driver)
-**												Signature             0x87974060(4)
-**												Request len           0x00000200(4)
-**												numbers of queue      0x00000100(4)
-**												SDRAM Size            0x00000100(4)-->256 MB
-**												IDE Channels          0x00000008(4)
-**												vendor                40 bytes char
-**												model                  8 bytes char
-**												FirmVer               16 bytes char
-**												Device Map            16 bytes char
-**
+**					Signature             0x87974060(4)
+**					Request len           0x00000200(4)
+**					numbers of queue      0x00000100(4)
+**					SDRAM Size            0x00000100(4)-->256 MB
+**					IDE Channels          0x00000008(4)
+**					vendor                40 bytes char
+**					model                  8 bytes char
+**					FirmVer               16 bytes char
+**					Device Map            16 bytes char
+**	
 **					FirmwareVersion DWORD <== Added for checking of new firmware capability
 **			0x02 : Set Config ->offset 0xa00 : for inbound message code msgcode_rwbuffer (driver send to IOP331)
-**												Signature             0x87974063(4)
-**												UPPER32 of Request Frame  (4)-->Driver Only
+**					Signature             0x87974063(4)
+**					UPPER32 of Request Frame  (4)-->Driver Only
 **			0x03 : Reset (Abort all queued Command)
 **			0x04 : Stop Background Activity
 **			0x05 : Flush Cache
 **			0x06 : Start Background Activity (re-start if background is halted)
 **			0x07 : Check If Host Command Pending (Novell May Need This Function)
 **			0x08 : Set controller time ->offset 0xa00 : for inbound message code msgcode_rwbuffer (driver to IOP331)
-**											byte 0 : 0xaa <-- signature
-**											byte 1 : 0x55 <-- signature
-**											byte 2 : year (04)
-**											byte 3 : month (1..12)
-**											byte 4 : date (1..31)
-**											byte 5 : hour (0..23)
-**											byte 6 : minute (0..59)
-**											byte 7 : second (0..59)
+**					byte 0 : 0xaa <-- signature
+**					byte 1 : 0x55 <-- signature
+**					byte 2 : year (04)
+**					byte 3 : month (1..12)
+**					byte 4 : date (1..31)
+**					byte 5 : hour (0..23)
+**					byte 6 : minute (0..59)
+**					byte 7 : second (0..59)
 **      *********************************************************************************
 **      Porting Of LSI2108/2116 Based PCIE SAS/6G host raid adapter
 **      ==> Difference from IOP348
 **      <1> Message Register 0,1 (the same usage) Init Thread message and retrun code
 **           Inbound Message 0  (inbound_msgaddr0) : at offset 0xB0 (Scratchpad0) for inbound message code msgcode_rwbuffer (driver send to IOP)
-**           Inbound Message 1  (inbound_msgaddr1) : at offset 0xB4 (Scratchpad1) Out.... Diag Status Code
-**           Outbound Message 0 (outbound_msgaddr0): at offset 0xB8 (Scratchpad3) Out.... Diag Status Code
+**           Inbound Message 1  (inbound_msgaddr1) : at offset 0xB4 (Scratchpad1) Out.... Diag Status Code 
+**           Outbound Message 0 (outbound_msgaddr0): at offset 0xB8 (Scratchpad3) Out.... Diag Status Code 
 **           Outbound Message 1 (outbound_msgaddr1): at offset 0xBC (Scratchpad2) for outbound message code msgcode_rwbuffer (IOP send to driver)
 **           <A> use doorbell to generate interrupt
 **
@@ -433,36 +779,36 @@ struct CMD_MESSAGE_FIELD {
 **
 **		        a. Message1: Out - Diag Status Code (????)
 **
-**		        b. Message0: message code
+**		        b. Message0: message code 
 **		        	    0x00 : NOP
 **		        	    0x01 : Get Config ->offset 0xB8 :for outbound message code msgcode_rwbuffer (IOP send to driver)
-**		        	    									Signature             0x87974060(4)
-**		        	    									Request len           0x00000200(4)
-**		        	    									numbers of queue      0x00000100(4)
-**		        	    									SDRAM Size            0x00000100(4)-->256 MB
-**		        	    									IDE Channels          0x00000008(4)
-**		        	    									vendor                40 bytes char
-**		        	    									model                  8 bytes char
-**		        	    									FirmVer               16 bytes char
-**                                      					Device Map            16 bytes char
-**                                      	                cfgVersion    ULONG <== Added for checking of new firmware capability
+**		        	    			Signature             0x87974060(4)
+**		        	    			Request len           0x00000200(4)
+**		        	    			numbers of queue      0x00000100(4)
+**		        	    			SDRAM Size            0x00000100(4)-->256 MB
+**		        	    			IDE Channels          0x00000008(4)
+**		        	    			vendor                40 bytes char
+**		        	    			model                  8 bytes char
+**		        	    			FirmVer               16 bytes char
+**                                         Device Map            16 bytes char
+**                                         cfgVersion    ULONG <== Added for checking of new firmware capability
 **		        	    0x02 : Set Config ->offset 0xB0 :for inbound message code msgcode_rwbuffer (driver send to IOP)
-**		        	    									Signature             0x87974063(4)
-**		        	    									UPPER32 of Request Frame  (4)-->Driver Only
+**		        	    			Signature             0x87974063(4)
+**		        	    			UPPER32 of Request Frame  (4)-->Driver Only
 **		        	    0x03 : Reset (Abort all queued Command)
 **		        	    0x04 : Stop Background Activity
 **		        	    0x05 : Flush Cache
 **		        	    0x06 : Start Background Activity (re-start if background is halted)
 **		        	    0x07 : Check If Host Command Pending (Novell May Need This Function)
 **		        	    0x08 : Set controller time ->offset 0xB0 : for inbound message code msgcode_rwbuffer (driver to IOP)
-**		        	            							byte 0 : 0xaa <-- signature
-**                                      					byte 1 : 0x55 <-- signature
-**		        	            							byte 2 : year (04)
-**		        	            							byte 3 : month (1..12)
-**		        	            							byte 4 : date (1..31)
-**		        	            							byte 5 : hour (0..23)
-**		        	            							byte 6 : minute (0..59)
-**		        	            							byte 7 : second (0..59)
+**		        	            		byte 0 : 0xaa <-- signature
+**                                      		byte 1 : 0x55 <-- signature
+**		        	            		byte 2 : year (04)
+**		        	            		byte 3 : month (1..12)
+**		        	            		byte 4 : date (1..31)
+**		        	            		byte 5 : hour (0..23)
+**		        	            		byte 6 : minute (0..59)
+**		        	            		byte 7 : second (0..59)
 **
 **      <2> Doorbell Register is used for RS-232 emulation
 **           <A> different clear register
@@ -527,13 +873,13 @@ struct CMD_MESSAGE_FIELD {
 **                      111: <= 0x0300 (reserved)
 **                  -----------------------------
 **                  if len > 0x300 the len always set as 0x300
-**                  -----------------------------
+**                  -----------------------------   
 **                  post addr = addr | ((len-1) >> 6) | 1
 **                  -----------------------------
-**                  page length in command buffer still required,
+**                  page length in command buffer still required, 
 **
-**                  if page length > 3,
-**                     firmware will assume more request data need to be retrieved
+**                  if page length > 3, 
+**                     firmware will assume more request data need to be retrieved 
 **
 **              <D> Outbound Posting
 **                  bit0:0 , no error, 1 with error, refer to status buffer
@@ -542,42 +888,12 @@ struct CMD_MESSAGE_FIELD {
 **                  bit3:0 , reserved (will be 0)
 **                  bit63-4: Completed command address
 **
-**              <E> BIOS support, no special support is required.
+**              <E> BIOS support, no special support is required. 
 **                  LSI2108 support I/O register
 **                  All driver functionality is supported through I/O address
 **
-**           For further spec, refer to
-**       \spec\lsi\2108 for Areca\2108\LSISAS2108_PG_NoEncryption.pdf : Chapter 8 (8-11/8-28)
-**       \spec\lsi\2108 for Areca\2108\SAS2108_RM_20.pdf              : for configuration space
 ************************************************************************************************
 */
-/* signature of set and get firmware config */
-#define ARCMSR_SIGNATURE_GET_CONFIG                   0x87974060
-#define ARCMSR_SIGNATURE_SET_CONFIG                   0x87974063
-/* message code of inbound message register */
-#define ARCMSR_INBOUND_MESG0_NOP                      0x00000000
-#define ARCMSR_INBOUND_MESG0_GET_CONFIG               0x00000001
-#define ARCMSR_INBOUND_MESG0_SET_CONFIG               0x00000002
-#define ARCMSR_INBOUND_MESG0_ABORT_CMD                0x00000003
-#define ARCMSR_INBOUND_MESG0_STOP_BGRB                0x00000004
-#define ARCMSR_INBOUND_MESG0_FLUSH_CACHE              0x00000005
-#define ARCMSR_INBOUND_MESG0_START_BGRB               0x00000006
-#define ARCMSR_INBOUND_MESG0_CHK331PENDING            0x00000007
-#define ARCMSR_INBOUND_MESG0_SYNC_TIMER               0x00000008
-/* doorbell interrupt generator */
-#define ARCMSR_INBOUND_DRIVER_DATA_WRITE_OK           0x00000001
-#define ARCMSR_INBOUND_DRIVER_DATA_READ_OK            0x00000002
-#define ARCMSR_OUTBOUND_IOP331_DATA_WRITE_OK          0x00000001
-#define ARCMSR_OUTBOUND_IOP331_DATA_READ_OK           0x00000002
-/* srb areca cdb flag */
-#define ARCMSR_SRBPOST_FLAG_SGL_BSIZE                 0x80000000
-#define ARCMSR_SRBPOST_FLAG_IAM_BIOS                  0x40000000
-#define ARCMSR_SRBREPLY_FLAG_IAM_BIOS                 0x40000000
-#define ARCMSR_SRBREPLY_FLAG_ERROR                    0x10000000
-#define ARCMSR_SRBREPLY_FLAG_ERROR_MODE0        	0x10000000
-#define ARCMSR_SRBREPLY_FLAG_ERROR_MODE1			0x00000001
-/* outbound firmware ok */
-#define ARCMSR_OUTBOUND_MESG1_FIRMWARE_OK             0x80000000
 /*
 **********************************
 **
@@ -585,21 +901,21 @@ struct CMD_MESSAGE_FIELD {
 */
 /* size 8 bytes */
 /* 32bit Scatter-Gather list */
-struct SG32ENTRY {                             /* length bit 24 == 0                      */
-    u_int32_t						length;    /* high 8 bit == flag,low 24 bit == length */
-    u_int32_t						address;
+struct SG32ENTRY {                 /* length bit 24 == 0 */
+	u_int32_t	length;    /* high 8 bit == flag,low 24 bit == length */
+	u_int32_t	address;
 };
 /* size 12 bytes */
 /* 64bit Scatter-Gather list */
-struct SG64ENTRY {                             /* length bit 24 == 1                      */
-	u_int32_t       				length;    /* high 8 bit == flag,low 24 bit == length */
-	u_int32_t       				address;
-	u_int32_t       				addresshigh;
+struct SG64ENTRY {                 /* length bit 24 == 1 */
+  	u_int32_t       length;    /* high 8 bit == flag,low 24 bit == length */
+   	u_int32_t       address; 
+   	u_int32_t       addresshigh;
 };
 struct SGENTRY_UNION {
 	union {
-		struct SG32ENTRY            sg32entry;   /* 30h   Scatter gather address  */
-		struct SG64ENTRY            sg64entry;   /* 30h                           */
+  		struct SG32ENTRY	sg32entry;   /* 30h   Scatter gather address  */
+  		struct SG64ENTRY	sg64entry;   /* 30h */
 	}u;
 };
 /*
@@ -609,9 +925,16 @@ struct SGENTRY_UNION {
 */
 struct QBUFFER {
 	u_int32_t     data_len;
-    u_int8_t      data[124];
+	u_int8_t      data[124];
 };
 /*
+**********************************
+*/
+typedef struct PHYS_ADDR64 {
+	u_int32_t	phyadd_low;
+	u_int32_t	phyadd_high;
+}PHYSADDR64;
+/*
 ************************************************************************************************
 **      FIRMWARE INFO
 ************************************************************************************************
